*$ CREATE SOURCE.FOR
*COPY SOURCE
*
*=== source ===========================================================*
*
      SUBROUTINE SOURCE ( NOMORE )

      INCLUDE '(DBLPRC)'
      INCLUDE '(DIMPAR)'
      INCLUDE '(IOUNIT)'
*
*----------------------------------------------------------------------*
*                                                                      *
*     Copyright (C) 1990-2010      by    Alfredo Ferrari & Paola Sala  *
*     All Rights Reserved.                                             *
*                                                                      *
*                                                                      *
*     New source for FLUKA9x-FLUKA20xy:                                *
*                                                                      *
*     Created on 07 January 1990   by    Alfredo Ferrari & Paola Sala  *
*                                                   Infn - Milan       *
*                                                                      *
*     Last change on  17-Oct-10    by    Alfredo Ferrari               *
*                                                                      *
*  This is just an example of a possible user written source routine.  *
*  note that the beam card still has some meaning - in the scoring the *
*  maximum momentum used in deciding the binning is taken from the     *
*  beam momentum.  Other beam card parameters are obsolete.            *
*                                                                      *
*       Output variables:                                              *
*                                                                      *
*              Nomore = if > 0 the run will be terminated              *
*                                                                      *
*----------------------------------------------------------------------*
*
      INCLUDE '(BEAMCM)'
      INCLUDE '(FHEAVY)'
      INCLUDE '(FLKSTK)'
      INCLUDE '(IOIOCM)'
      INCLUDE '(LTCLCM)'
      INCLUDE '(PAPROP)'
      INCLUDE '(SOURCM)'
      INCLUDE '(SUMCOU)'
*
      LOGICAL LFIRST
*
      SAVE LFIRST
      DATA LFIRST / .TRUE. /
      INTEGER EventN / 0 /
      SAVE EventN
      integer NTESTS / 0 /
      SAVE NTESTS
      integer i
!       real*8 KEnergy
      real*8 FluxType
      real*8 Xc
      real*8 Yc
      real*8 X0
      real*8 Y0
      real*8 Z0
      real*8 Z1
      real*8 D1
      real*8 Z2
      real*8 D2
      real*8 D22
      real*8 EDistr
      real*8 E0
      real*8 E1
      real*8 Gamma
      real*8 TgThMax
      real*8 CosThMax
      real*8 GFRef
      real*8 Alpha
      real*8 CosTh
      real*8 SinTh
      real*8 Phi
      real*8 CosX
      real*8 CosY
      real*8 CosZ
      real*8 X1
      real*8 Y1
      real*8 X2
      real*8 Y2
      real*8 LgE0
      real*8 LgE1
      real*8 LgER
      real*8 ER
      real*8 PR
*======================================================================*
*                                                                      *
*                 BASIC VERSION                                        *
*                                                                      *
*======================================================================*
      NOMORE = 0
*  +-------------------------------------------------------------------*
*  |  First call initializations:
      IF ( LFIRST ) THEN
*  |  *** The following 3 cards are mandatory ***
         TKESUM = ZERZER
         LFIRST = .FALSE.
         LUSSRC = .TRUE.
*  |  *** User initialization ***
         WRITE(*,*) 'SOURCE CALLED FIRST TIME'
         do i = 1, 12
           WRITE(*,*) i, WHASOU(i)
         end do
         OPEN(2, ACCESS = 'SEQUENTIAL', ACTION = 'WRITE', 
     &                      FILE = '../Source.dat')
         ENDFILE 2
         CLOSE(2)
         FluxType = WHASOU(1)
         Z1 = WHASOU(2) 
         D1 = WHASOU(3)
         Z2 = WHASOU(4)
         D2 = WHASOU(5)
         EDistr = WHASOU(6)
         E0 = WHASOU(7)
         E1 = WHASOU(8)
         Gamma = WHASOU(9)
      END IF
*  |
*  +-------------------------------------------------------------------*
*  Push one source particle to the stack. Note that you could as well
*  push many but this way we reserve a maximum amount of space in the
*  stack for the secondaries to be generated
*  Npflka is the stack counter: of course any time source is called it
*  must be =0
      NPFLKA = NPFLKA + 1
*  Wt is the weight of the particle
      WTFLK  (NPFLKA) = ONEONE
      WEIPRI = WEIPRI + WTFLK (NPFLKA)
*  Particle type (1=proton.....). Ijbeam is the type set by the BEAM
*  card
      EventN = EventN + 1
      WRITE(*,*) 'SOURCE CALLED', EventN
*  +-------------------------------------------------------------------*
*  |  Heavy ion:
      IF ( IJBEAM .EQ. -2 ) THEN
         IJHION = IPROZ  * 1000 + IPROA
         IJHION = IJHION * 100 + KXHEAV
         IONID  = IJHION
         CALL DCDION ( IONID )
         CALL SETION ( IONID )
         ILOFLK (NPFLKA) = IJHION
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |  Group number for "low" energy neutrons, set to 0 anyway
         IGROUP (NPFLKA) = 0
*  |
*  +-------------------------------------------------------------------*
*  |  Normal hadron:
      ELSE
         IONID = IJBEAM
         ILOFLK (NPFLKA) = IJBEAM
*  |  Flag this is prompt radiation
         LRADDC (NPFLKA) = .FALSE.
*  |  Group number for "low" energy neutrons, set to 0 anyway
         IGROUP (NPFLKA) = 0
      END IF
*  |
*  +-------------------------------------------------------------------*
*
*
*
! *  From this point .....
! *  Particle generation (1 for primaries)
!       LOFLK  (NPFLKA) = 1
! *  User dependent flag:
!       LOUSE  (NPFLKA) = 0
! *  No channeling:
!       LCHFLK (NPFLKA) = .FALSE.
!       DCHFLK (NPFLKA) = ZERZER
! *  User dependent spare variables:
!       DO 100 ISPR = 1, MKBMX1
!          SPAREK (ISPR,NPFLKA) = ZERZER
!  100  CONTINUE
! *  User dependent spare flags:
!       DO 200 ISPR = 1, MKBMX2
!          ISPARK (ISPR,NPFLKA) = 0
!  200  CONTINUE
! *  Save the track number of the stack particle:
!       ISPARK (MKBMX2,NPFLKA) = NPFLKA
!       NPARMA = NPARMA + 1
!       NUMPAR (NPFLKA) = NPARMA
!       NEVENT (NPFLKA) = 0
!       DFNEAR (NPFLKA) = +ZERZER
! *  ... to this point: don't change anything
*
*  From this point .....
*  Particle generation (1 for primaries)
      LOFLK  (NPFLKA) = 1
*  User dependent flag:
      LOUSE  (NPFLKA) = 0
*  No channeling:
      KCHFLK (NPFLKA) = 0
      ECRFLK (NPFLKA) = ZERZER
*  Extra infos:
      INFSTK (NPFLKA) = 0
      LNFSTK (NPFLKA) = 0
      ANFSTK (NPFLKA) = ZERZER
*  Parent variables:
      IPRSTK (NPFLKA) = 0
      EKPSTK (NPFLKA) = ZERZER
*  User dependent spare variables:
      DO 100 ISPR = 1, MKBMX1
         SPAREK (ISPR,NPFLKA) = ZERZER
 100  CONTINUE
*  User dependent spare flags:
      DO 200 ISPR = 1, MKBMX2
         ISPARK (ISPR,NPFLKA) = 0
 200  CONTINUE
*  Save the track number of the stack particle:
      ISPARK (MKBMX2,NPFLKA) = NPFLKA
      NPARMA = NPARMA + 1
      NUMPAR (NPFLKA) = NPARMA
      NEVENT (NPFLKA) = 0
      DFNEAR (NPFLKA) = +ZERZER
*  ... to this point: don't change anything
*
*
*  Particle age (s)
      AGESTK (NPFLKA) = +ZERZER
      AKNSHR (NPFLKA) = -TWOTWO
*      
*      
*      
*      
*      
* BEGIN Energy *****************************************************
*  Kinetic energy of the particle (GeV)
      IF (EDistr .LT. 0.5) THEN ! EDistr == 0
        TKEFLK (NPFLKA) = SQRT(PBEAM**2 + AM (IONID)**2) - AM (IONID)
*  Particle momentum
        PMOFLK (NPFLKA) = PBEAM
*       PMOFLK (NPFLKA) = SQRT ( TKEFLK (NPFLKA) * ( TKEFLK (NPFLKA)
*    &                       + TWOTWO * AM (IONID) ) )
      ELSEIF (EDistr .LT. 1.5) THEN ! EDistr == 1
        LgE0 = LOG10(E0)
        LgE1 = LOG10(E1)
        LgER = LgE0 + FLRNDM(dummy)*ABS(LgE1 - LgE0)
        ER = 10.**LgER
        PR = SQRT(ER*(ER + TWOTWO*AM(IONID)))
*        TKEFLK (NPFLKA) = SQRT(PBEAM**2 + AM (IONID)**2) - AM (IONID)
*        PMOFLK (NPFLKA) = PBEAM
        TKEFLK(NPFLKA) = ER
        PMOFLK(NPFLKA) = PR
      ELSE
        CONTINUE
      ENDIF
* END Energy *******************************************************
*
*
*
*
*
* BEGIN TRAJECTORY *************************************************
      IF (FluxType .LT. 0.5) THEN      ! FluxType == 0
*  Cosines (tx,ty,tz)
        TXFLK  (NPFLKA) = UBEAM
        TYFLK  (NPFLKA) = VBEAM
        TZFLK  (NPFLKA) = WBEAM
*  Particle coordinates
        XFLK   (NPFLKA) = XBEAM
        YFLK   (NPFLKA) = YBEAM
        ZFLK   (NPFLKA) = ZBEAM
      ELSEIF (FluxType .LT. 1.5) THEN ! FluxType == 1
        TgThMax = (D1 + D2)/(Z2 - Z1)/SQRTWO
        CosThMax = 1./SQRT(1. + TgThMax**2)
        GFRef = PIPIPI*(1. - CosThMax**2)*(D1/100.)**2 ! m2 ster
        D22 = D2/2.
        Xc = 28.5
        Yc = 28.5
        DO
          NTests = NTests + 1
          Alpha = FLRNDM(dummy)
          CosTh = 1. - Alpha*(1. - CosThMax)
          SinTh = SQRT(1. - CosTh**2)
          Phi = FLRNDM(dummy)*TWOPIP
          CosX = SinTh*COS(Phi)
          CosY = SinTh*SIN(Phi)
          CosZ = CosTh
          X1 = Xc + D1*(FLRNDM(dummy) - .5)
          Y1 = Yc + D1*(FLRNDM(dummy) - .5)
          X2 = X1 + (Z2 - Z1)*CosX/CosZ
          Y2 = Y1 + (Z2 - Z1)*CosY/CosZ
          IF ((Xc-D22 .LE. X2) .AND. (X2 .LE. Xc+D22) .AND. 
     &        (Yc-D22 .LE. Y2) .AND. (Y2 .LE. Yc+D22)) THEN
            EXIT
          ENDIF
        ENDDO
        Z0 = -100.
        X0 = X1 + (Z0 - Z1)*CosX/CosZ
        Y0 = Y1 + (Z0 - Z1)*CosY/CosZ
        TXFLK  (NPFLKA) = CosX
        TYFLK  (NPFLKA) = CosY
        TZFLK  (NPFLKA) = CosZ
        XFLK   (NPFLKA) = X0
        YFLK   (NPFLKA) = Y0
        ZFLK   (NPFLKA) = Z0
        WRITE(*,*) 'GFRef =', GFRef, 'NTests =', NTests
      ELSE                             ! FluxType == 2
        CONTINUE
      ENDIF
* BEGIN TRAJECTORY *************************************************
*
*
*
*
*
*
*
*
*  Polarization cosines:
      TXPOL  (NPFLKA) = -TWOTWO
      TYPOL  (NPFLKA) = +ZERZER
      TZPOL  (NPFLKA) = +ZERZER
*      
      OPEN(2, ACCESS = 'APPEND', ACTION = 'WRITE', 
     &                      FILE = '../Source.dat')
!       WRITE(*,*) '1: IJBEAM =', IJBEAM
      IF (IJBEAM .EQ. -2) THEN
!         WRITE(*,*) '2: IJBEAM =', IJBEAM
        WRITE(2, *) EVENTN, IJBEAM, IPROZ, IPROA, TKEFLK(NPFLKA), 
     &              XFLK(NPFLKA), YFLK(NPFLKA), ZFLK(NPFLKA), 
     &              TXFLK(NPFLKA), TYFLK(NPFLKA), TZFLK(NPFLKA)
      ELSE
!         WRITE(*,*) '3: IJBEAM =', IJBEAM
        WRITE(2, *) EVENTN, IJBEAM, 0, 0, TKEFLK(NPFLKA), 
     &              XFLK(NPFLKA), YFLK(NPFLKA), ZFLK(NPFLKA), 
     &              TXFLK(NPFLKA), TYFLK(NPFLKA), TZFLK(NPFLKA)
      ENDIF
      CLOSE(2)
*      
*  Calculate the total kinetic energy of the primaries: don't change
      IF ( ILOFLK (NPFLKA) .EQ. -2 .OR. ILOFLK (NPFLKA) .GT. 100000 )
     &   THEN
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      ELSE IF ( ILOFLK (NPFLKA) .NE. 0 ) THEN
         TKESUM = TKESUM + ( TKEFLK (NPFLKA) + AMDISC (ILOFLK(NPFLKA)) )
     &          * WTFLK (NPFLKA)
      ELSE
         TKESUM = TKESUM + TKEFLK (NPFLKA) * WTFLK (NPFLKA)
      END IF
      RADDLY (NPFLKA) = ZERZER
*  Here we ask for the region number of the hitting point.
*     NREG (NPFLKA) = ...
*  The following line makes the starting region search much more
*  robust if particles are starting very close to a boundary:
      CALL GEOCRS ( TXFLK (NPFLKA), TYFLK (NPFLKA), TZFLK (NPFLKA) )
      CALL GEOREG ( XFLK  (NPFLKA), YFLK  (NPFLKA), ZFLK  (NPFLKA),
     &              NRGFLK(NPFLKA), IDISC )
*  Do not change these cards:
      CALL GEOHSM ( NHSPNT (NPFLKA), 1, -11, MLATTC )
      NLATTC (NPFLKA) = MLATTC
      CMPATH (NPFLKA) = ZERZER
      CALL SOEVSV
      RETURN
*=== End of subroutine Source =========================================*
      END

